package p11_enkapsulacja;

public class Konto {
    private final int numer;
    private int saldo;
    private Osoba wlasciciel;

    public Konto(int numer, int saldo, Osoba wlasciciel) {
        this.numer = numer;
        this.saldo = saldo;
        this.wlasciciel = wlasciciel;
    }

    public int getNumer() {
        return numer;
    }

    public int getSaldo() {
        return saldo;
    }

    public Osoba getWlasciciel() {
        return wlasciciel;
    }

    public void setWlasciciel(Osoba wlasciciel) {
        this.wlasciciel = wlasciciel;
    }

    // Z dwóch różnych powodów nie tworzymy setterów dla pól
    // - numer - ponieważ numer się nie zmienia (takie pole powinno być oznaczone final)
    // - saldo - bo nie chce by ktoś ustawił wartość saldo "bez żadnego trybu",
    //           do zmiany salda bedą służyć dedykowane "metody biznesowe"
    public boolean wplata(int kwota) {
        if(kwota > 0) {
            saldo += kwota;
            return true;
        } else {
            return false;
        }
    }

    public void wyplata(int kwota) {
        saldo -= kwota;
    }

    public void przelew(int kwota, Konto docelowe) {
        saldo -= kwota;
        docelowe.saldo += kwota;
        // operacja na polu innego obiektu - dopuszczalna
    }

    @Override
    public String toString() {
        return "Konto nr " + numer + ", saldo=" + saldo + ", wł=" + wlasciciel;
    }
}
